package cn.com.tenlion.configcontent.service.contentcollect;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.configcontent.pojo.dtos.contentcollect.ContentCollectDTO;
import cn.com.tenlion.configcontent.pojo.vos.contentcollect.ContentCollectVO;
import cn.com.tenlion.configcontent.pojo.bos.contentcollect.ContentCollectBO;
import cn.com.tenlion.configcontent.pojo.pos.contentcollect.ContentCollectPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IContentCollectService
 * @Description: 
 * @Author: CodeFactory
 * @Date: 2021-08-02 09:15:31
 * @Version: 3.0
 **/
public interface IContentCollectService {

    /**
     * 新增
     *
     * @param contentCollectVO
     * @return
     */
    void save(ContentCollectVO contentCollectVO);

    /**
     * 新增
     *
     * @param token
     * @param contentCollectVO
     * @return
     */
    void save(String token, ContentCollectVO contentCollectVO);

    /**
     * 新增
     *
     * @param contentCollectVO
     * @return contentCollectId
     */
    String saveReturnId(ContentCollectVO contentCollectVO);

    /**
     * 新增
     *
     * @param token
     * @param contentCollectVO
     * @return contentCollectId
     */
    String saveReturnId(String token, ContentCollectVO contentCollectVO);

    /**
     * 删除
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除（物理删除）
     *
     * @param contentCollectId id列表
     */
    void delete(String contentCollectId);

    /**
     * 修改
     *
     * @param contentCollectId
     * @param contentCollectVO
     * @return
     */
    void update(String contentCollectId, ContentCollectVO contentCollectVO);

    /**
     * 修改
     *
     * @param token
     * @param contentCollectId
     * @param contentCollectVO
     * @return
     */
    void update(String token, String contentCollectId, ContentCollectVO contentCollectVO);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ContentCollectDTO get(Map<String, Object> params);

    /**
     * 详情
     *
     * @param contentCollectId
     * @return
     */
    ContentCollectDTO get(String contentCollectId);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ContentCollectBO getBO(Map<String, Object> params);

    /**
     * 详情
     *
     * @param contentCollectId
     * @return
     */
    ContentCollectBO getBO(String contentCollectId);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ContentCollectPO getPO(Map<String, Object> params);

    /**
     * 详情
     *
     * @param contentCollectId
     * @return
     */
    ContentCollectPO getPO(String contentCollectId);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ContentCollectDTO> list(Map<String, Object> params);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ContentCollectBO> listBO(Map<String, Object> params);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ContentCollectPO> listPO(Map<String, Object> params);

    /**
     * 分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<ContentCollectDTO>> listPage(ListPage page);

    /**
     * 统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}